<?php

	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check Array Input
	PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();
	// Check access rights
	PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_ONLY, 'record_sa_target');
	
	if
	(
		PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
		(
			[
					'PARAM_REC_SATARGET_ID',
					'PARAM_REC_SATARGET_ACC_ACCOUNT_ID',
					'PARAM_REC_SATARGET_DESCRIPTION',
					'PARAM_REC_SATARGET_VALUE_FROM',
					'PARAM_REC_SATARGET_VALUE_TO',
					'PARAM_REC_SATARGET_TYPE_FROM',
					'PARAM_REC_SATARGET_TYPE_TO',
					'PARAM_REC_SATARGET_DATE_FROM',
					'PARAM_REC_SATARGET_DATE_TO',
					'PARAM_REC_SATARGET_STATUS',
					
					'PARAM_ORDER_FIELD',
					'PARAM_ORDER_TYPE',
					'PARAM_SKIP',
					'PARAM_LIMIT'
			], True
		)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------	
			$PARAM_REC_SATARGET_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_SATARGET_ID');
			$PARAM_REC_SATARGET_ACC_ACCOUNT_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_SATARGET_ACC_ACCOUNT_ID');
			$PARAM_REC_SATARGET_DESCRIPTION = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_SATARGET_DESCRIPTION');
			$PARAM_REC_SATARGET_VALUE_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_SATARGET_VALUE_FROM');
			$PARAM_REC_SATARGET_VALUE_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_SATARGET_VALUE_TO');
			$PARAM_REC_SATARGET_TYPE_FROM = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_SATARGET_TYPE_FROM');
			$PARAM_REC_SATARGET_TYPE_TO = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_SATARGET_TYPE_TO');
			$PARAM_REC_SATARGET_DATE_FROM = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_SATARGET_DATE_FROM');
			$PARAM_REC_SATARGET_DATE_TO = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_SATARGET_DATE_TO');
			$PARAM_REC_SATARGET_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_SATARGET_STATUS');
			
			$PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
			(
					'PARAM_ORDER_FIELD',
					[
						'REC_SATARGET_ID', 
						'REC_SATARGET_ACC_ACCOUNT_ID', 
						'REC_SATARGET_DESCRIPTION', 
						'REC_SATARGET_VALUE', 
						'REC_SATARGET_TYPE', 
						'REC_SATARGET_DATE', 
						'REC_SATARGET_STATUS'
						, 
						'ACC_ACCOUNT_ID',		
						'ACC_ACCOUNT_SERVER_ID',		
						'ACC_ACCOUNT_ACC_LEVEL_ID',		
						'ACC_ACCOUNT_ACC_GROUP_ID',		
						'ACC_ACCOUNT_ADD_RESOURCE_ID',		
						'ACC_ACCOUNT_USERNAME',		
						'ACC_ACCOUNT_PASSWORD',		
						'ACC_ACCOUNT_AUTH_CODE',		
						'ACC_ACCOUNT_FIRST_NAME',		
						'ACC_ACCOUNT_MIDDLE_NAME',		
						'ACC_ACCOUNT_LAST_NAME',		
						'ACC_ACCOUNT_POSITION',		
						'ACC_ACCOUNT_SYS_GENDER_ID',		
						'ACC_ACCOUNT_STATUS',		
						'ACC_ACCOUNT_SYSTEM_GENERATED'		
					]
			);		
			$PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
			$PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
			$PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
			
			// ------------------------------------------------------------------
			
			
			// Populate Map Array
			// ...........................................
			$GET_MAP_ARRAY = PHPCUS_RECORD_SA_TARGET::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			
			$GET_MAP_ARRAY['PARAM_REC_SATARGET_ID'] = $PARAM_REC_SATARGET_ID;
			$GET_MAP_ARRAY['PARAM_REC_SATARGET_ACC_ACCOUNT_ID'] = $PARAM_REC_SATARGET_ACC_ACCOUNT_ID;
			$GET_MAP_ARRAY['PARAM_REC_SATARGET_DESCRIPTION'] = $PARAM_REC_SATARGET_DESCRIPTION;
			$GET_MAP_ARRAY['PARAM_REC_SATARGET_VALUE_FROM'] = $PARAM_REC_SATARGET_VALUE_FROM;
			$GET_MAP_ARRAY['PARAM_REC_SATARGET_VALUE_TO'] = $PARAM_REC_SATARGET_VALUE_TO;
			$GET_MAP_ARRAY['PARAM_REC_SATARGET_TYPE_FROM'] = $PARAM_REC_SATARGET_TYPE_FROM;
			$GET_MAP_ARRAY['PARAM_REC_SATARGET_TYPE_TO'] = $PARAM_REC_SATARGET_TYPE_TO;
			$GET_MAP_ARRAY['PARAM_REC_SATARGET_DATE_FROM'] = $PARAM_REC_SATARGET_DATE_FROM;
			$GET_MAP_ARRAY['PARAM_REC_SATARGET_DATE_TO'] = $PARAM_REC_SATARGET_DATE_TO;
			$GET_MAP_ARRAY['PARAM_REC_SATARGET_STATUS'] = $PARAM_REC_SATARGET_STATUS;
			
			$GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
			$GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
			$GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
			$GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
			
			
			// Execute Stored Procedure
			// ...........................................
			$DATA_SET = PHPCUS_RECORD_SA_TARGET::CUS_GET_MA($GET_MAP_ARRAY);
			
						
			// Return JSON response
			// ...........................................
			if(empty($DATA_SET) === False)
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
			}
			else
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS('');
			}
			
		}
		Catch(Exception $ERR)
		{		
			PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
			if(isset($_SERVER['HTTP_ORIGIN']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_ORIGIN', $_SERVER['HTTP_ORIGIN']);
			}
			if(isset($_SERVER['HTTP_HOST']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_HOST', $_SERVER['HTTP_HOST']);
			}		
			if(isset($_SERVER['HTTP_REFERER']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_REFERER', $_SERVER['HTTP_REFERER']);
			}
			if(isset($_SERVER['REMOTE_ADDR']))
			{
			    PHPVC_LOG::VAR_ERROR('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
			}
			
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>